Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -26,4 +26,10 @@
 ! -----------------
 ! $Id$
+! Use PALM's working precision
+! Catch errors while reading namelists
+! Improved coding style
+!
+! 
+! 3802 2019-03-17 13:33:42Z raasch
 ! unused variable removed
 ! 
@@ -131,8 +137,8 @@
     USE inifor_control
     USE inifor_defs,                                                           &
-        ONLY:  DATE, EARTH_RADIUS, TO_RADIANS, TO_DEGREES, PI, dp, hp, sp,     &
+        ONLY:  DATE, EARTH_RADIUS, TO_RADIANS, TO_DEGREES, PI,                 &
                SNAME, LNAME, PATH, FORCING_STEP, WATER_ID, FILL_ITERATIONS,    &
                BETA, P_SL, T_SL, BETA, RD, RV, G, P_REF, RD_PALM, CP_PALM,     &
-               RHO_L, OMEGA, HECTO
+               RHO_L, OMEGA, HECTO, wp, iwp
     USE inifor_io,                                                             &
         ONLY:  get_cosmo_grid, get_netcdf_attribute, get_netcdf_dim_vector,    &
@@ -140,5 +146,5 @@
                get_input_file_list, validate_config
     USE inifor_transform,                                                      &
-        ONLY:  average_2d, rotate_to_cosmo, find_horizontal_neighbours,&
+        ONLY:  average_2d, rotate_to_cosmo, find_horizontal_neighbours,        &
                compute_horizontal_interp_weights,                              &
                find_vertical_neighbours_and_weights_interp,                    &
@@ -156,81 +162,82 @@
     SAVE
     
-    REAL(dp) ::  averaging_angle   = 0.0_dp       !< latitudal and longitudal width of averaging regions [rad]
-    REAL(dp) ::  averaging_width_ns = 0.0_dp       !< longitudal width of averaging regions [m]
-    REAL(dp) ::  averaging_width_ew = 0.0_dp       !< latitudal width of averaging regions [m]
-    REAL(dp) ::  phi_equat         = 0.0_dp       !< latitude of rotated equator of COSMO-DE grid [rad]
-    REAL(dp) ::  phi_n             = 0.0_dp       !< latitude of rotated pole of COSMO-DE grid [rad]
-    REAL(dp) ::  lambda_n          = 0.0_dp       !< longitude of rotaded pole of COSMO-DE grid [rad]
-    REAL(dp) ::  phi_c             = 0.0_dp       !< rotated-grid latitude of the center of the PALM domain [rad]
-    REAL(dp) ::  lambda_c          = 0.0_dp       !< rotated-grid longitude of the centre of the PALM domain [rad]
-    REAL(dp) ::  phi_cn            = 0.0_dp       !< latitude of the rotated pole relative to the COSMO-DE grid [rad]
-    REAL(dp) ::  lambda_cn         = 0.0_dp       !< longitude of the rotated pole relative to the COSMO-DE grid [rad]
-    REAL(dp) ::  lam_centre        = 0.0_dp       !< longitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  phi_centre        = 0.0_dp       !< latitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  lam_east          = 0.0_dp       !< longitude of the east central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  lam_west          = 0.0_dp       !< longitude of the west central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  phi_north         = 0.0_dp       !< latitude of the north central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  phi_south         = 0.0_dp       !< latitude of the south central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
-    REAL(dp) ::  gam               = 0.0_dp       !< angle for working around phirot2phi/rlarot2rla bug
-    REAL(dp) ::  dx                = 0.0_dp       !< PALM-4U grid spacing in x direction [m]
-    REAL(dp) ::  dy                = 0.0_dp       !< PALM-4U grid spacing in y direction [m]
-    REAL(dp) ::  dz(10)            = -1.0_dp      !< PALM-4U grid spacing in z direction [m]
-    REAL(dp) ::  dz_max            = 1000.0_dp    !< maximum vertical grid spacing [m]
-    REAL(dp) ::  dz_stretch_factor = 1.08_dp      !< factor for vertical grid stretching [m]
-    REAL(dp) ::  dz_stretch_level  = -9999999.9_dp!< height above which the vertical grid will be stretched [m]
-    REAL(dp) ::  dz_stretch_level_start(9) = -9999999.9_dp !< namelist parameter
-    REAL(dp) ::  dz_stretch_level_end(9) = 9999999.9_dp !< namelist parameter
-    REAL(dp) ::  dz_stretch_factor_array(9) = 1.08_dp !< namelist parameter
-    REAL(dp) ::  dxi               = 0.0_dp       !< inverse PALM-4U grid spacing in x direction [m^-1]
-    REAL(dp) ::  dyi               = 0.0_dp       !< inverse PALM-4U grid spacing in y direction [m^-1]
-    REAL(dp) ::  dzi               = 0.0_dp       !< inverse PALM-4U grid spacing in z direction [m^-1]
-    REAL(dp) ::  f3                = 0.0_dp       !< Coriolis parameter
-    REAL(dp) ::  lx                = 0.0_dp       !< PALM-4U domain size in x direction [m]
-    REAL(dp) ::  ly                = 0.0_dp       !< PALM-4U domain size in y direction [m]
-    REAL(dp) ::  p0                = 0.0_dp       !< PALM-4U surface pressure, at z0 [Pa]
-    REAL(dp) ::  x0                = 0.0_dp       !< x coordinate of PALM-4U Earth tangent [m] 
-    REAL(dp) ::  y0                = 0.0_dp       !< y coordinate of PALM-4U Earth tangent [m] 
-    REAL(dp) ::  z0                = 0.0_dp       !< Elevation of the PALM-4U domain above sea level [m]
-    REAL(dp) ::  z_top             = 0.0_dp       !< height of the scalar top boundary [m]
-    REAL(dp) ::  zw_top            = 0.0_dp       !< height of the vertical velocity top boundary [m]
-    REAL(dp) ::  lonmin_cosmo      = 0.0_dp       !< Minimunm longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-    REAL(dp) ::  lonmax_cosmo      = 0.0_dp       !< Maximum longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-    REAL(dp) ::  latmin_cosmo      = 0.0_dp       !< Minimunm latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-    REAL(dp) ::  latmax_cosmo      = 0.0_dp       !< Maximum latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
-    REAL(dp) ::  lonmin_palm       = 0.0_dp       !< Minimunm longitude of PALM grid [COSMO rotated-pole rad]
-    REAL(dp) ::  lonmax_palm       = 0.0_dp       !< Maximum longitude of PALM grid [COSMO rotated-pole rad]
-    REAL(dp) ::  latmin_palm       = 0.0_dp       !< Minimunm latitude of PALM grid [COSMO rotated-pole rad]
-    REAL(dp) ::  latmax_palm       = 0.0_dp       !< Maximum latitude of PALM grid [COSMO rotated-pole rad]
-    REAL(dp) ::  lonmin_tot        = 0.0_dp       !< Minimunm longitude of required COSMO data [COSMO rotated-pole rad]
-    REAL(dp) ::  lonmax_tot        = 0.0_dp       !< Maximum longitude of required COSMO data [COSMO rotated-pole rad]
-    REAL(dp) ::  latmin_tot        = 0.0_dp       !< Minimunm latitude of required COSMO data [COSMO rotated-pole rad]
-    REAL(dp) ::  latmax_tot        = 0.0_dp       !< Maximum latitude of required COSMO data [COSMO rotated-pole rad]
-    REAL(dp) ::  latitude          = 0.0_dp       !< geographical latitude of the PALM-4U origin, from inipar namelist [deg]
-    REAL(dp) ::  longitude         = 0.0_dp       !< geographical longitude of the PALM-4U origin, from inipar namelist [deg]
-    REAL(dp) ::  origin_lat        = 0.0_dp       !< geographical latitude of the PALM-4U origin, from static driver netCDF file [deg]
-    REAL(dp) ::  origin_lon        = 0.0_dp       !< geographical longitude of the PALM-4U origin, from static driver netCDF file [deg]
-    REAL(dp) ::  rotation_angle    = 0.0_dp       !< clockwise angle the PALM-4U north is rotated away from geographical north [deg]
-    REAL(dp) ::  end_time          = 0.0_dp       !< PALM-4U simulation time [s]
-
-    REAL(dp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  hhl             !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from external file
-    REAL(dp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  hfl             !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  depths          !< COSMO-DE's TERRA-ML soil layer depths
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  d_depth         !< COSMO-DE's TERRA-ML soil layer thicknesses
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  d_depth_rho_inv !< inverted soil water mass
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  rlon            !< longitudes of COSMO-DE's rotated-pole grid
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  rlat            !< latitudes of COSMO-DE's rotated-pole grid
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  time            !< output times 
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  x               !< base palm grid x coordinate vector pointed to by grid_definitions
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  xu              !< base palm grid xu coordinate vector pointed to by grid_definitions
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  y               !< base palm grid y coordinate vector pointed to by grid_definitions
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  yv              !< base palm grid yv coordinate vector pointed to by grid_definitions
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  z_column        !< base palm grid z coordinate vector including the top boundary coordinate (entire column)
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  zw_column       !< base palm grid zw coordinate vector including the top boundary coordinate (entire column)
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  z               !< base palm grid z coordinate vector pointed to by grid_definitions
-    REAL(dp), DIMENSION(:), ALLOCATABLE, TARGET     ::  zw              !< base palm grid zw coordinate vector pointed to by grid_definitions
-
-    INTEGER(hp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  soiltyp      !< COSMO-DE soil type map
+    REAL(wp) ::  averaging_angle   = 0.0_wp       !< latitudal and longitudal width of averaging regions [rad]
+    REAL(wp) ::  averaging_width_ns = 0.0_wp       !< longitudal width of averaging regions [m]
+    REAL(wp) ::  averaging_width_ew = 0.0_wp       !< latitudal width of averaging regions [m]
+    REAL(wp) ::  phi_equat         = 0.0_wp       !< latitude of rotated equator of COSMO-DE grid [rad]
+    REAL(wp) ::  phi_n             = 0.0_wp       !< latitude of rotated pole of COSMO-DE grid [rad]
+    REAL(wp) ::  lambda_n          = 0.0_wp       !< longitude of rotaded pole of COSMO-DE grid [rad]
+    REAL(wp) ::  phi_c             = 0.0_wp       !< rotated-grid latitude of the center of the PALM domain [rad]
+    REAL(wp) ::  lambda_c          = 0.0_wp       !< rotated-grid longitude of the centre of the PALM domain [rad]
+    REAL(wp) ::  phi_cn            = 0.0_wp       !< latitude of the rotated pole relative to the COSMO-DE grid [rad]
+    REAL(wp) ::  lambda_cn         = 0.0_wp       !< longitude of the rotated pole relative to the COSMO-DE grid [rad]
+    REAL(wp) ::  lam_centre        = 0.0_wp       !< longitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  phi_centre        = 0.0_wp       !< latitude of the PLAM domain centre in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  lam_east          = 0.0_wp       !< longitude of the east central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  lam_west          = 0.0_wp       !< longitude of the west central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  phi_north         = 0.0_wp       !< latitude of the north central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  phi_south         = 0.0_wp       !< latitude of the south central-averaging-domain boundary in the source (COSMO rotated-pole) system [rad]
+    REAL(wp) ::  gam               = 0.0_wp       !< angle for working around phirot2phi/rlarot2rla bug
+    REAL(wp) ::  dx                = 0.0_wp       !< PALM-4U grid spacing in x direction [m]
+    REAL(wp) ::  dy                = 0.0_wp       !< PALM-4U grid spacing in y direction [m]
+    REAL(wp) ::  dz(10)            = -1.0_wp      !< PALM-4U grid spacing in z direction [m]
+    REAL(wp) ::  dz_max            = 1000.0_wp    !< maximum vertical grid spacing [m]
+    REAL(wp) ::  dz_stretch_factor = 1.08_wp      !< factor for vertical grid stretching [m]
+    REAL(wp) ::  dz_stretch_level  = -9999999.9_wp!< height above which the vertical grid will be stretched [m]
+    REAL(wp) ::  dz_stretch_level_start(9) = -9999999.9_wp !< namelist parameter
+    REAL(wp) ::  dz_stretch_level_end(9) = 9999999.9_wp !< namelist parameter
+    REAL(wp) ::  dz_stretch_factor_array(9) = 1.08_wp !< namelist parameter
+    REAL(wp) ::  dxi               = 0.0_wp       !< inverse PALM-4U grid spacing in x direction [m^-1]
+    REAL(wp) ::  dyi               = 0.0_wp       !< inverse PALM-4U grid spacing in y direction [m^-1]
+    REAL(wp) ::  dzi               = 0.0_wp       !< inverse PALM-4U grid spacing in z direction [m^-1]
+    REAL(wp) ::  f3                = 0.0_wp       !< Coriolis parameter
+    REAL(wp) ::  lx                = 0.0_wp       !< PALM-4U domain size in x direction [m]
+    REAL(wp) ::  ly                = 0.0_wp       !< PALM-4U domain size in y direction [m]
+    REAL(wp) ::  p0                = 0.0_wp       !< PALM-4U surface pressure, at z0 [Pa]
+    REAL(wp) ::  x0                = 0.0_wp       !< x coordinate of PALM-4U Earth tangent [m] 
+    REAL(wp) ::  y0                = 0.0_wp       !< y coordinate of PALM-4U Earth tangent [m] 
+    REAL(wp) ::  z0                = 0.0_wp       !< Elevation of the PALM-4U domain above sea level [m]
+    REAL(wp) ::  z_top             = 0.0_wp       !< height of the scalar top boundary [m]
+    REAL(wp) ::  zw_top            = 0.0_wp       !< height of the vertical velocity top boundary [m]
+    REAL(wp) ::  lonmin_cosmo      = 0.0_wp       !< Minimunm longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp) ::  lonmax_cosmo      = 0.0_wp       !< Maximum longitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp) ::  latmin_cosmo      = 0.0_wp       !< Minimunm latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp) ::  latmax_cosmo      = 0.0_wp       !< Maximum latitude of COSMO-DE's rotated-pole grid [COSMO rotated-pole rad]
+    REAL(wp) ::  lonmin_palm       = 0.0_wp       !< Minimunm longitude of PALM grid [COSMO rotated-pole rad]
+    REAL(wp) ::  lonmax_palm       = 0.0_wp       !< Maximum longitude of PALM grid [COSMO rotated-pole rad]
+    REAL(wp) ::  latmin_palm       = 0.0_wp       !< Minimunm latitude of PALM grid [COSMO rotated-pole rad]
+    REAL(wp) ::  latmax_palm       = 0.0_wp       !< Maximum latitude of PALM grid [COSMO rotated-pole rad]
+    REAL(wp) ::  lonmin_tot        = 0.0_wp       !< Minimunm longitude of required COSMO data [COSMO rotated-pole rad]
+    REAL(wp) ::  lonmax_tot        = 0.0_wp       !< Maximum longitude of required COSMO data [COSMO rotated-pole rad]
+    REAL(wp) ::  latmin_tot        = 0.0_wp       !< Minimunm latitude of required COSMO data [COSMO rotated-pole rad]
+    REAL(wp) ::  latmax_tot        = 0.0_wp       !< Maximum latitude of required COSMO data [COSMO rotated-pole rad]
+    REAL(wp) ::  latitude          = 0.0_wp       !< geographical latitude of the PALM-4U origin, from inipar namelist [deg]
+    REAL(wp) ::  longitude         = 0.0_wp       !< geographical longitude of the PALM-4U origin, from inipar namelist [deg]
+    REAL(wp) ::  origin_lat        = 0.0_wp       !< geographical latitude of the PALM-4U origin, from static driver netCDF file [deg]
+    REAL(wp) ::  origin_lon        = 0.0_wp       !< geographical longitude of the PALM-4U origin, from static driver netCDF file [deg]
+    REAL(wp) ::  rotation_angle    = 0.0_wp       !< clockwise angle the PALM-4U north is rotated away from geographical north [deg]
+    REAL(wp) ::  end_time          = 0.0_wp       !< PALM-4U simulation time [s]
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  hhl             !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from external file
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  hfl             !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  depths          !< COSMO-DE's TERRA-ML soil layer depths
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  d_depth         !< COSMO-DE's TERRA-ML soil layer thicknesses
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  d_depth_rho_inv !< inverted soil water mass
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  rlon            !< longitudes of COSMO-DE's rotated-pole grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  rlat            !< latitudes of COSMO-DE's rotated-pole grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  time            !< output times 
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  x               !< base palm grid x coordinate vector pointed to by grid_definitions
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  xu              !< base palm grid xu coordinate vector pointed to by grid_definitions
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  y               !< base palm grid y coordinate vector pointed to by grid_definitions
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  yv              !< base palm grid yv coordinate vector pointed to by grid_definitions
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  z_column        !< base palm grid z coordinate vector including the top boundary coordinate (entire column)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  zw_column       !< base palm grid zw coordinate vector including the top boundary coordinate (entire column)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  z               !< base palm grid z coordinate vector pointed to by grid_definitions
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET     ::  zw              !< base palm grid zw coordinate vector pointed to by grid_definitions
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  soiltyp     !< COSMO-DE soil type map
     INTEGER ::  dz_stretch_level_end_index(9)               !< vertical grid level index until which the vertical grid spacing is stretched
     INTEGER ::  dz_stretch_level_start_index(9)             !< vertical grid level index above which the vertical grid spacing is stretched
+    INTEGER ::  iostat !< return status of READ statement
     INTEGER ::  nt    !< number of output time steps
     INTEGER ::  nx    !< number of PALM-4U grid points in x direction
@@ -355,5 +362,5 @@
 !> interplation grids later in setup_grids().
 !------------------------------------------------------------------------------!
-    SUBROUTINE setup_parameters()
+ SUBROUTINE setup_parameters()
 
 !
@@ -361,44 +368,44 @@
 ! Section 1: Define default parameters
 !------------------------------------------------------------------------------
-       cfg % start_date = '2013072100'
-       end_hour = 2
-       start_hour_soil = -2
-       start_hour_soilmoisture = - (4 * 7 * 24) - 2
-
-!
-!--    Defaultmain centre (_c) of the PALM-4U grid in the geographical system (_g)
-       origin_lat = 52.325079_dp * TO_RADIANS ! south-west of Berlin, origin used for the Dec 2017 showcase simulation
-       origin_lon = 13.082744_dp * TO_RADIANS
-       cfg % z0 = 35.0_dp
-
-!
-!--    Default atmospheric parameters
-       cfg % ug = 0.0_dp
-       cfg % vg = 0.0_dp
-       cfg % p0 = P_SL
-
-!
-!--    Parameters for file names
-       start_hour_flow = 0
-       start_hour_soil = 0
-       start_hour_radiation = 0
-       start_hour_soilmoisture = start_hour_flow - 2
-       end_hour_soilmoisture = start_hour_flow
-       step_hour = FORCING_STEP
-
-       input_prefix = 'laf'
-       cfg % flow_prefix = input_prefix
-       cfg % input_prefix = input_prefix
-       cfg % soil_prefix = input_prefix
-       cfg % radiation_prefix = input_prefix
-       cfg % soilmoisture_prefix  = input_prefix
-
-       flow_suffix = '-flow'
-       soil_suffix = '-soil'
-       radiation_suffix = '-rad'
-       soilmoisture_suffix = '-soilmoisture'
-
-       cfg % debug = .FALSE.
-       cfg % averaging_angle = 2.0_dp
+    cfg%start_date = '2013072100'
+    end_hour = 2
+    start_hour_soil = -2
+    start_hour_soilmoisture = - (4 * 7 * 24) - 2
+
+!
+!-- Defaultmain centre (_c) of the PALM-4U grid in the geographical system (_g)
+    origin_lat = 52.325079_wp * TO_RADIANS ! south-west of Berlin, origin used for the Dec 2017 showcase simulation
+    origin_lon = 13.082744_wp * TO_RADIANS
+    cfg%z0 = 35.0_wp
+
+!
+!-- Default atmospheric parameters
+    cfg%ug = 0.0_wp
+    cfg%vg = 0.0_wp
+    cfg%p0 = P_SL
+
+!
+!-- Parameters for file names
+    start_hour_flow = 0
+    start_hour_soil = 0
+    start_hour_radiation = 0
+    start_hour_soilmoisture = start_hour_flow - 2
+    end_hour_soilmoisture = start_hour_flow
+    step_hour = FORCING_STEP
+
+    input_prefix = 'laf'
+    cfg%flow_prefix = input_prefix
+    cfg%input_prefix = input_prefix
+    cfg%soil_prefix = input_prefix
+    cfg%radiation_prefix = input_prefix
+    cfg%soilmoisture_prefix  = input_prefix
+
+    flow_suffix = '-flow'
+    soil_suffix = '-soil'
+    radiation_suffix = '-rad'
+    soilmoisture_suffix = '-soilmoisture'
+
+    cfg%debug = .FALSE.
+    cfg%averaging_angle = 2.0_wp
 !
 !------------------------------------------------------------------------------
@@ -407,88 +414,102 @@
 
 !
-!--    Set default paths and modes
-       cfg % input_path         = './'
-       cfg % hhl_file           = ''
-       cfg % soiltyp_file       = ''
-       cfg % namelist_file      = './namelist'
-       cfg % static_driver_file = ''
-       cfg % output_file = './palm-4u-input.nc'
-       cfg % ic_mode = 'volume'
-       cfg % bc_mode = 'real'
-       cfg % averaging_mode = 'level'
-
-!
-!--    Overwrite defaults with user configuration
-       CALL parse_command_line_arguments( cfg )
-       CALL report('main_loop', 'Running INIFOR version ' // VERSION)
-
-       flow_prefix = TRIM(cfg % input_prefix)
-       radiation_prefix = TRIM(cfg % input_prefix)
-       soil_prefix = TRIM(cfg % input_prefix)
-       soilmoisture_prefix = TRIM(cfg % input_prefix)
-       IF (cfg % flow_prefix_is_set)  flow_prefix = TRIM(cfg % flow_prefix)
-       IF (cfg % radiation_prefix_is_set)  radiation_prefix = TRIM(cfg % radiation_prefix)
-       IF (cfg % soil_prefix_is_set)  soil_prefix = TRIM(cfg % soil_prefix)
-       IF (cfg % soilmoisture_prefix_is_set)  soilmoisture_prefix = TRIM(cfg % soilmoisture_prefix)
-
-       output_file % name = cfg % output_file
-       z0 = cfg % z0
-       p0 = cfg % p0
-
-       init_variables_required = .TRUE.
-       boundary_variables_required = TRIM( cfg % bc_mode ) == 'real'
-       ls_forcing_variables_required = TRIM( cfg % bc_mode ) == 'ideal'
-       surface_forcing_required = .FALSE.
-
-       IF ( ls_forcing_variables_required )  THEN
-          message = "Averaging of large-scale forcing profiles " //            &
-                    "has not been implemented, yet."
-          CALL inifor_abort('setup_parameters', message)
-       ENDIF
-
-!
-!--    Set default file paths, if not specified by user.
-       CALL normalize_path(cfg % input_path)
-       IF (TRIM(cfg % hhl_file) == '')  cfg % hhl_file = TRIM(cfg % input_path) // 'hhl.nc'
-       IF (TRIM(cfg % soiltyp_file) == '')  cfg % soiltyp_file = TRIM(cfg % input_path) // 'soil.nc'
-
-       CALL validate_config( cfg ) 
-
-       CALL report('setup_parameters', "initialization mode: " // TRIM(cfg % ic_mode))
-       CALL report('setup_parameters', "       forcing mode: " // TRIM(cfg % bc_mode))
-       CALL report('setup_parameters', "     averaging mode: " // TRIM(cfg % averaging_mode))
-       CALL report('setup_parameters', "    averaging angle: " // real_to_str(cfg % averaging_angle))
-       CALL report('setup_parameters', "          data path: " // TRIM(cfg % input_path))
-       CALL report('setup_parameters', "           hhl file: " // TRIM(cfg % hhl_file))
-       CALL report('setup_parameters', "       soiltyp file: " // TRIM(cfg % soiltyp_file))
-       CALL report('setup_parameters', "      namelist file: " // TRIM(cfg % namelist_file))
-       CALL report('setup_parameters', "   output data file: " // TRIM(output_file % name))
-       IF (cfg % debug )  CALL report('setup_parameters', "     debugging mode: enabled")
-
- CALL run_control('time', 'init')
- !
- !--   Read in namelist parameters
-       OPEN(10, FILE=cfg % namelist_file)
-       READ(10, NML=inipar) ! nx, ny, nz, dx, dy, dz
-       READ(10, NML=d3par)  ! end_time
+!-- Set default paths and modes
+    cfg%input_path         = './'
+    cfg%hhl_file           = ''
+    cfg%soiltyp_file       = ''
+    cfg%namelist_file      = './namelist'
+    cfg%static_driver_file = ''
+    cfg%output_file = './palm-4u-input.nc'
+    cfg%ic_mode = 'volume'
+    cfg%bc_mode = 'real'
+    cfg%averaging_mode = 'level'
+
+!
+!-- Overwrite defaults with user configuration
+    CALL parse_command_line_arguments( cfg )
+    CALL report('main_loop', 'Running INIFOR version ' // VERSION)
+
+    flow_prefix = TRIM(cfg%input_prefix)
+    radiation_prefix = TRIM(cfg%input_prefix)
+    soil_prefix = TRIM(cfg%input_prefix)
+    soilmoisture_prefix = TRIM(cfg%input_prefix)
+    IF (cfg%flow_prefix_is_set)  flow_prefix = TRIM(cfg%flow_prefix)
+    IF (cfg%radiation_prefix_is_set)  radiation_prefix = TRIM(cfg%radiation_prefix)
+    IF (cfg%soil_prefix_is_set)  soil_prefix = TRIM(cfg%soil_prefix)
+    IF (cfg%soilmoisture_prefix_is_set)  soilmoisture_prefix = TRIM(cfg%soilmoisture_prefix)
+
+    output_file%name = cfg%output_file
+    z0 = cfg%z0
+    p0 = cfg%p0
+
+    init_variables_required = .TRUE.
+    boundary_variables_required = TRIM( cfg%bc_mode ) == 'real'
+    ls_forcing_variables_required = TRIM( cfg%bc_mode ) == 'ideal'
+    surface_forcing_required = .FALSE.
+
+    IF ( ls_forcing_variables_required )  THEN
+       message = "Averaging of large-scale forcing profiles " //            &
+                 "has not been implemented, yet."
+       CALL inifor_abort('setup_parameters', message)
+    ENDIF
+
+!
+!-- Set default file paths, if not specified by user.
+    CALL normalize_path(cfg%input_path)
+    IF (TRIM(cfg%hhl_file) == '')  cfg%hhl_file = TRIM(cfg%input_path) // 'hhl.nc'
+    IF (TRIM(cfg%soiltyp_file) == '')  cfg%soiltyp_file = TRIM(cfg%input_path) // 'soil.nc'
+
+    CALL validate_config( cfg ) 
+
+    CALL report('setup_parameters', "initialization mode: " // TRIM(cfg%ic_mode))
+    CALL report('setup_parameters', "       forcing mode: " // TRIM(cfg%bc_mode))
+    CALL report('setup_parameters', "     averaging mode: " // TRIM(cfg%averaging_mode))
+    CALL report('setup_parameters', "    averaging angle: " // real_to_str(cfg%averaging_angle))
+    CALL report('setup_parameters', "          data path: " // TRIM(cfg%input_path))
+    CALL report('setup_parameters', "           hhl file: " // TRIM(cfg%hhl_file))
+    CALL report('setup_parameters', "       soiltyp file: " // TRIM(cfg%soiltyp_file))
+    CALL report('setup_parameters', "      namelist file: " // TRIM(cfg%namelist_file))
+    CALL report('setup_parameters', "   output data file: " // TRIM(output_file%name))
+    IF (cfg%debug )  CALL report('setup_parameters', "     debugging mode: enabled")
+
+    CALL log_runtime('time', 'init')
+!
+!-- Read in namelist parameters
+    OPEN(10, FILE=cfg%namelist_file, STATUS='old')
+    READ(10, NML=inipar, IOSTAT=iostat) ! nx, ny, nz, dx, dy, dz    
+    IF ( iostat > 0 )  THEN      
+       message = "Failed to read namelist 'inipar' from file '" //             &
+                 TRIM( cfg%namelist_file ) // "'. "
+       CALL inifor_abort( 'setup_parameters', message )
        CLOSE(10)
- CALL run_control('time', 'read')
-
-       end_hour = CEILING( end_time / 3600.0 * step_hour )
-
-!
-!--    Generate input file lists
-       CALL get_input_file_list(                                               &
-          cfg % start_date, start_hour_flow, end_hour, step_hour,              &
-          cfg % input_path, flow_prefix, flow_suffix, flow_files)
-       CALL get_input_file_list(                                               &
-          cfg % start_date, start_hour_soil, end_hour, step_hour,              &
-          cfg % input_path, soil_prefix, soil_suffix, soil_files)
-       CALL get_input_file_list(                                               &
-          cfg % start_date, start_hour_radiation, end_hour, step_hour,         &
-          cfg % input_path, radiation_prefix, radiation_suffix, radiation_files, nocheck=.TRUE.)
-       CALL get_input_file_list(                                               &
-          cfg % start_date, start_hour_soilmoisture, end_hour_soilmoisture, step_hour, &
-          cfg % input_path, soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files, nocheck=.TRUE.)
+    ENDIF
+
+    READ(10, NML=d3par, IOSTAT=iostat)  ! end_time
+    IF ( iostat > 0 )  THEN
+       message = "Failed to read namelist 'd3par' from file '" //              &
+                 TRIM( cfg%namelist_file ) // "'. "
+       CALL inifor_abort( 'setup_parameters', message )
+       CLOSE(10)
+    ENDIF
+    CLOSE(10)
+    
+    CALL log_runtime('time', 'read')
+
+    end_hour = CEILING( end_time / 3600.0 * step_hour )
+
+!
+!-- Generate input file lists
+    CALL get_input_file_list(                                               &
+       cfg%start_date, start_hour_flow, end_hour, step_hour,              &
+       cfg%input_path, flow_prefix, flow_suffix, flow_files)
+    CALL get_input_file_list(                                               &
+       cfg%start_date, start_hour_soil, end_hour, step_hour,              &
+       cfg%input_path, soil_prefix, soil_suffix, soil_files)
+    CALL get_input_file_list(                                               &
+       cfg%start_date, start_hour_radiation, end_hour, step_hour,         &
+       cfg%input_path, radiation_prefix, radiation_suffix, radiation_files, nocheck=.TRUE.)
+    CALL get_input_file_list(                                               &
+       cfg%start_date, start_hour_soilmoisture, end_hour_soilmoisture, step_hour, &
+       cfg%input_path, soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files, nocheck=.TRUE.)
 
 !
